<?php
 
/*
* plugin name: Custom metabox with media uploader
* Plugin URI: http://web.contempo.jp/weblog/tips/p617
* description: Adding metabox with custom media uploader to editing pages.
* author: Mizuho Ogino
* author URI: http://web.contempo.jp/
* version: 1.2
* license: http://www.gnu.org/licenses/gpl.html GPL v2 or later
*/
 
/////////////////////// メタボックスの追加と保存 /////////////////////// 
 
add_action( 'admin_init', 'my_upload_metaboxs_init' );
function my_upload_metaboxs_init(){ // 投稿編集画面にメタボックスを追加する
    add_meta_box( 'my_upload', 'マイアップロード画像', 'my_upload_postmeta', 'post', 'side','high' ); // カスタム投稿の場合はpostをお好きなポストタイプに変更します
    add_action( 'save_post', 'save_my_upload_postmeta' );
}
 
 
/////////////////////// メタボックス（画像アップロード用） /////////////////////// 
  
function my_upload_postmeta(){ //投稿ページに表示されるカスタムフィールド
    global $post;
    $post_id = $post->ID;
    $my_upload_li = '';
    $my_upload_images = get_post_meta( $post_id, 'my_upload_images', true );
    if ( $my_upload_images): foreach( $my_upload_images as $key => $img_id ):
        $thumb_src = wp_get_attachment_image_src ($img_id,'medium'); // サムネイルのときはthumbnailを指定
        if ( empty ($thumb_src[0]) ){ //画像が存在しない空IDを強制的に取り除く
            delete_post_meta( $post_id, 'my_upload_images', $img_id );
        } else {
            $my_upload_li.= 
            "\t".'<li class="img" id="img_'.$img_id.'">'."\n".
            "\t\t".'<span class="img_wrap">'."\n".
            "\t\t\t".'<a href="#" class="my_upload_images_remove" title="画像を削除する"></a>'."\n".
            "\t\t\t".'<img src="'.$thumb_src[0].'"/>'."\n".
            "\t\t\t".'<input type="hidden" name="my_upload_images[]" value="'.$img_id.'" />'."\n".
            "\t\t".'</span>'."\n".
            "\t".'</li>'."\n";
        }
    endforeach; endif;
?>
<style type="text/css">
    #my_upload .inside { padding-top:8px; padding-bottom:13px; }
    #my_upload_images { display:block; list-style-type:none; margin:0; padding:0; }
    #my_upload_images:after { content:''; display:block; height:0; clear:both; visibility:hidden; }
    #my_upload_images li { float:left; margin:6px; padding:0; height:160px; }
    #my_upload_images li span { display:inline-block; max-width:100%; margin:0; padding:5px; position:relative; background:#ddd; -webkit-box-sizing:border-box; -moz-box-sizing:border-box; box-sizing:border-box; }
    #my_upload_images li span:hover { background:#9cc; cursor:move; }
    #my_upload_images li span img { margin:0; padding:0; max-height:150px; width:auto; vertical-align:text-bottom; }
    #my_upload_images li span input { display:none; }
    @media screen and (min-width : 851px){
        #side-sortables #my_upload_images li { height:auto; float:none; width:100%; margin:11px auto; text-align:center; }
        #side-sortables #my_upload_images li span img { max-height:130px; max-width:100%; width:auto; height:auto; }
    }
    @media screen and (max-width : 850px){
        #my_upload_images li { float:left; margin:8px; padding:0; height:138px; }
        #my_upload_images li span { padding:4px; }
        #my_upload_images li span img { max-height:130px; max-width:100%; width:auto; height:auto; }
    }
    #my_upload_images li span a.my_upload_images_remove { position:absolute; top:-9px; right:-9px; height:32px; width:32px; text-align:center; vertical-align:middle; background:#ddd; border-radius:50%; }
    #my_upload_images li span a.my_upload_images_remove::before { content:'×'; display:inline-block; text-decoration:none; width:1em; margin-right:.2em; text-align:center; font-size:20px; line-height:20px; padding:6px; color:#fff; font-weight:bold; }
    #my_upload_images li span a.my_upload_images_remove:hover { background:#387; }
    #my_upload_buttons a { padding:6px; margin-bottom:20px; height:32px; width:100%; line-height:20px; font-weight:bold; text-align:center; }
</style>
<div id="my_upload_buttons">
    <a id="my_upload_media" type="button" class="button" title="画像を追加・変更">アイテム画像の追加・編集</a>
</div>
<ul id="my_upload_images">
<?php echo $my_upload_li; ?>
</ul>
<input type="hidden" name="my_nonce" value="<?php echo wp_create_nonce(basename(__FILE__)); ?>" />
<script type="text/javascript">
jQuery( function( $ ){
    var custom_uploader;
    $( '#my_upload_media' ).click( function( e ) {
        e.preventDefault();
        if (custom_uploader) {
            custom_uploader.open();
            return;
        }
        custom_uploader = wp.media({
            state : 'mystate',
            title: _wpMediaViewsL10n.mediaLibraryTitle,
            library: {
                type: 'image'
            },
            button: {
                text: '画像を選択'
            },
            multiple: true, // falseのとき画像選択は一つのみ可能
            frame: 'select', // select | post. selectは左のnavを取り除く指定
            editing: false,
        });
        custom_uploader.states.add([
            new wp.media.controller.Library({
                id:         'mystate',
                title: 'アイテム画像のアップロード',
                priority:   20,
                toolbar:    'select',
                filterable: 'uploaded',
                library:    wp.media.query( custom_uploader.options.library ),
                multiple:   custom_uploader.options.multiple ? 'reset' : false,
                editable:   true,
                displayUserSettings: false,
                displaySettings: true,
                allowLocalEdits: true
            }),
        ]);
        custom_uploader.on( 'ready', function( ){
            $( 'select.attachment-filters [value="uploaded"]' ).attr( 'selected', true ).parent().trigger('change'); //「この投稿へのアップロード」をデフォルト表示　不要ならコメントアウト
        }).on( 'open', function( ){
            $( '.media-frame' ).addClass( 'hide-menu' ).addClass( 'hide-router' ); // 左側のメニュー消去
        }).on( 'select', function( ){ 
            var selection = custom_uploader.state().get( 'selection' ),
                this_id = 0,
                ex_ul = $( '#my_upload_images' ),
                ex_ids = [];
            ex_ul.children( 'li' ).each( function( ){
                this_id = Number( $(this).attr( 'id' ).slice(4) );
                ex_ids.push( this_id );
            });
            selection.each( function( file ){
                this_id = file.toJSON().id;
                if ( $.inArray( this_id, ex_ids ) > -1 ){ // 投稿編集画面のリストに重複している場合、削除
                    ex_ul.find( 'li#img_' + this_id ).remove();
                }
                ex_ul.append( '<li class="img" id="img_' + this_id + '"></li>' ).find( 'li:last' ).append(
                    '<span class="img_wrap">' + 
                    '<a href="#" class="my_upload_images_remove" title="この画像を削除する"></a>' +
                    '<a href="post.php?post='+ this_id +'&amp;action=edit" class="my_upload_images_edit" title="画像の情報を編集する"></a>' +
                    '<img src="' + file.attributes.url + '" />' + // サムネイルのときはfile.attributes.sizes.medium.urlを指定
                    '<input type="hidden" name="my_upload_images[]" value="'+ this_id +'" />' + 
                    '</span>'
                );
            });
        });
        custom_uploader.open();
    });
    $( '.my_upload_images_remove' ).live( 'click', function( e ) {
        e.preventDefault();
        e.stopPropagation();
        img_obj = $(this).parents( 'li.img' ).remove();
    });
    $( '#my_upload_images' ).sortable({
        cursor : 'move',
        tolerance : 'pointer',
        opacity: 0.6
    });
});
</script>
<?php }
  
/*データ更新時の保存*/
function save_my_upload_postmeta( $post_id ){
    if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) return $post_id; // 自動保存ルーチンの時は何もしない
    if ( !isset($_POST['my_nonce']) || isset($_POST['my_nonce']) && !wp_verify_nonce($_POST['my_nonce'], basename(__FILE__))) return $post_id; // wp-nonceチェック
    if ( 'page' == $_POST['post_type'] ) {
        if ( !current_user_can( 'edit_page', $post_id ) ) return $post_id; // パーミッションチェック
    } else {
        if ( !current_user_can( 'edit_post', $post_id ) ) return $post_id; // パーミッションチェック
    }
    $new_images = isset($_POST['my_upload_images']) ? $_POST['my_upload_images']: null; //POSTされたデータ
    $ex_images = get_post_meta( $post_id, 'my_upload_images', true ); //DBのデータ
    if ( $ex_images !== $new_images ){
        if ( $new_images ){
            update_post_meta( $post_id, 'my_upload_images', $new_images ); // アップデート
        } else {
            delete_post_meta( $post_id, 'my_upload_images', $ex_images ); // 登録画像無し
        }
    }
}

?>